
Ruby - Bug #14892

r63763 breaks -DMJIT_FORCE_ENABLE=1

07/03/2018 09:51 AM - normalperson (Eric Wong)

Status: Closed   

Priority: Normal   

Assignee: k0kubun (Takashi Kokubun)   

Target version:    

ruby -v:  Backport: 2.3: UNKNOWN, 2.4: UNKNOWN, 2.5:

UNKNOWN

Description

r63763 ("give up insn attr handles_frame") breaks -DMJIT_FORCE_ENABLE=1

(commit 6b534134a78e3e43c344682c3585e1abab015216 in git)

Related [Bug #14809] [Bug #14834]

Is this being worked on? I mentioned it in [ruby-core:87674],

"make test" fails in test_insns.rb for me on Debian 9 (x86 and amd64).

Not sure what's wrong.

Reverting that commit allows even "make exam" to pass for me.

Associated revisions

Revision 8bec3e1fe257fa75403be737ca86fba0e5606bf8 - 07/07/2018 02:41 PM - k0kubun (Takashi Kokubun)

insns.def: stop pushing unnecessary keys for MJIT

[Bug #14892]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@63875 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 8bec3e1fe257fa75403be737ca86fba0e5606bf8 - 07/07/2018 02:41 PM - k0kubun (Takashi Kokubun)

insns.def: stop pushing unnecessary keys for MJIT

[Bug #14892]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@63875 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 8bec3e1f - 07/07/2018 02:41 PM - k0kubun (Takashi Kokubun)

insns.def: stop pushing unnecessary keys for MJIT

[Bug #14892]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@63875 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

History

#1 - 07/03/2018 11:44 AM - k0kubun (Takashi Kokubun)

- Assignee set to k0kubun (Takashi Kokubun)

I recognize that. I'm currently taking time for RubyBench project but planning to take a look after that. Please ignore the -DMJIT_FORCE_ENABLE=1

until I fix it.

#2 - 07/05/2018 12:02 AM - wanabe (_ wanabe)

A mini reproductive command is here.

ruby --jit-wait --disable=gems -e '1000.times { a, b = nil }'

#3 - 07/05/2018 03:42 AM - wanabe (_ wanabe)

And another one.
ruby --jit-wait --disable-gems -e '1000.times { break if /a/ =~ "ab" && !$~[0] }'

#4 - 07/06/2018 12:49 AM - wanabe (_ wanabe)

Many cases (including a, b = nil) go well after r63863.

Now I found that there remain 2 issues at least.

1. pc is set to next_pos when insn is opt_xxx and body->catch_except_p is falsy.

ex. 1000.times { break if /a/ =~ "ab" && !$~[0] }

2. opt_aref_with / opt_aset_with push rb_str_resurrect(key) when MJIT execution is cancelled, but it is unexpected for VM's opt_aref_with /

opt_aset_with.

ex. 1000.times { Thread.current["a"] = {} }

#5 - 07/07/2018 02:41 PM - k0kubun (Takashi Kokubun)

- Status changed from Open to Closed

Applied in changeset trunk|r63875.

insns.def: stop pushing unnecessary keys for MJIT

[Bug #14892]

Files

r63763-fail.log 37 KB 07/03/2018 normalperson (Eric Wong)
